Redmine - Defect #31021

Fullwidth characters enclosed in "<" and ">" are removed in email notifications
2019-03-13 07:51 - Masaomi Yoshida

Status: Confirmed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Email notifications Estimated time: 0.00 hour

Target version:

Resolution: Affected version: 3.4.7

Description
Hi, I'm using Redmine ver.3.4.7 and multi-byte environment(Japanese).

| found a bug in mail notifications function.
When | update a ticket with the comments below

aaa<bbb>ccc

000<000-000

The less-than sign, grater-than sign, and multi-byte "BBB" are deleted in the mail, while the ticket itself is properly updated.
Note that the first sentence is written using single-byte characters, and the second one is written using multi-byte characters except
less-than sign(<) and grater-than sign(>).

It will not happen when the letters are quoted with < pre > and < /pre >.
Neither It will not happen when html mail is not used.

See the attached for details.

History

#1 - 2019-03-13 08:01 - Go MAEDA
- File email-4.png added

| cannot reproduce the problem in the current trunk (Redmine 4.0.2.devel.17938). | will check with 3.4 later.

<foo><bar><baz>
<a href="https://www.redmine.org/">Redmine</a>
<span>redmine</span>

#2 - 2019-03-13 08:08 - Masaomi Yoshida

Maeda-san,
Thanks for prompt response and trying to reproduce.

| forgot saying this but if characters are all single-byte in < and >, the bug will not happen.
It happens only when the characters include multi-byte characters.

Please try using my sample in description section.

aaa<bbb>ccc
go0<000>000

#3 - 2019-03-13 08:47 - Go MAEDA

- Status changed from New to Confirmed

Masaomi Yoshida wrote:
It happens only when the characters include multi-byte characters.

Thank you for pointing it out. | have confirmed that the issue is reproducible in the current trunk.

#4 - 2019-03-13 09:05 - Go MAEDA

- Subject changed from Letters/Words are deleted in mails when multi-byte characters are in less-than sign(<) and grater-than sign(>) to Fullwidth

characters enclosed in "<" and ">" are removed in email notifications

#5 - 2019-03-28 05:50 - Yuichi HARADA

- File 0001-Remove-unnecessary-trailing-white-spaces.patch added
- File 0002-Fullwidth-characters-enclosed-in-It-and-gt.patch added

- File 0003-Add-tests.patch added

Escape processing of "<" and ">" is performed by RedCloth3#escape_html_tags .
source:/trunk/lib/redmine/wiki_formatting/textile/redcloth3.rb#L. 1218

However, full-width characters could not be processed because they do not match the regular expression "w".

Change the regular expression "w" to "_" and "[[:alnum:]]" to match even full-width characters.

| attached the patches.

#6 - 2019-03-28 09:00 - Go MAEDA

- Target version set to Candidate for next minor release

#7 - 2019-03-29 10:50 - Go MAEDA

| tested the patch and found that the problem still remains for strings such as "<###>" and "<00000>".

#8 - 2019-04-23 17:44 - Go MAEDA

- Target version deleted (Candidate for next minor release)

Files

Redmine_notification_mail.png 4.26 KB 2019-03-13 Masaomi Yoshida
email-4.png 26.4 KB 2019-03-13 Go MAEDA
0001-Remove-unnecessary-trailing-white-spaces.patch 23.6 KB 2019-03-28 Yuichi HARADA
0002-Fullwidth-characters-enclosed-in-It-and-gt.patch 1 KB 2019-03-28 Yuichi HARADA
0003-Add-tests.patch 2.17 KB 2019-03-28 Yuichi HARADA
